#include <stdio.h>

  /* Fibonaccijevi brojevi - rekurzivno.
     Ispisuje povratne vrijednosti svakog poziva,
     zajedno s rednim brojem poziva.

     Cilj: Zelimo da redni broj poziva bude korektan,
     tj. da odgovara redoslijedu prilikom ispisa.
     Treci pokusaj - radi dobro. */

  /* Koristi globalni (static) brojac poziva, koji se
     automatski inicijalizira na 0 prilikom deklaracije. */

long int broj_poziva;

    /* Rekurzivni Fibonacci. */

long int fib(int n)
{
    long int vrijednost;

    if (n == 0)
        vrijednost = 0;
    else if (n == 1)
        vrijednost = 1;
    else
        vrijednost = fib(n - 1) + fib(n - 2);

        /* Povecavamo brojac tik prije izlaska. */
        /* To JE dovoljno, jer ce ostali pozivi
           zavrsiti svoj posao PRIJE ovog ispisa
           i promjene brojaca. NE TREBA pamtiti
           brojac. Osim toga, brojac tocno
           odgovara redosljedu ispisa. */
    ++broj_poziva;

    printf(" Povratna vrijednost %ld. poziva je %ld\n",
            broj_poziva, vrijednost);

    return vrijednost;
}

    /* Glavni program za demo. */

int main (void)
{
    printf("fib(3) = %ld\n", fib(3));

        /* Prije nastavka, ima smisla vratiti broj_poziva na 0.
           Namjerno NIJE napravljeno, za demo ispis. */

    printf("fib(5) = %ld\n", fib(5));

    return 0;
}
