#include <stdio.h>

  /* Particije - Osnovni problem:
       Broj rastava zadanog prirodnog broja n u sumu
     nepadajucih (prirodnih) pribrojnika.
     Dozvoljen je i samo jedan pribrojnik.

     Rekurzivno generira (broji i zbraja) sve particije.
     Osnovni rekurzivni algoritam (poput parts_1.c, par_0.c).

     Ucitava (prirodni) broj n,
     ispisuje broj opisanih particija p(n).
     Ispisuje i broj rekurzivnih poziva funkcije.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;


    /* Nadji sve opisane particije broja suma u kojima je
       prvi (sljedeci) pribrojnik barem jednak broju prvi. */

int particije(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Provjera kraja rekurzije i jesmo li nasli rastav. */
    if (suma == 0) return 1;

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           uz ogranicenje prvi <= i <= suma:
           - preostala suma je suma - i,
           - sljedeci prvi je barem i. */

    for (i = prvi; i <= suma; ++i)
        broj += particije(suma - i, i);

    return broj;
}

    /* Nerekurzivna funkcija za racunanje p(n).
       Zove rekurzivnu funkciju particije,
       s dodatnim argumentom prvi = 1. */

int p(int n)
{
        /* Poziv rekurzivne funkcije particije, s prvi = 1. */
    return particije(n, 1);
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

    broj_poziva = 0u;

    printf("\n\n");
    printf(" Broj particija p(%d) = %d\n",
           n, p(n));
    printf(" Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
