#include <stdio.h>

  /* Particije - Varijacija 2:
       Broj rastava zadanog prirodnog broja n u sumu
     nepadajucih (prirodnih) pribrojnika, s tim da je
     razlika susjednih pribrojnika barem k, gdje je
     k >= 0 zadani cijeli broj.
     Dozvoljen je i samo jedan pribrojnik.

     Rekurzivno generira (broji i zbraja) sve particije.
     Osnovni rekurzivni algoritam (poput parts_1.c, par_0.c).

     Ucitava (prirodne) brojeve n i k,
     ispisuje broj opisanih particija p_2(n, k).
     Ispisuje i broj rekurzivnih poziva funkcije.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;


    /* Nadji sve opisane particije broja suma u kojima je
       prvi (sljedeci) pribrojnik barem jednak broju prvi. */

int particije_2(int suma, int k, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Provjera kraja rekurzije i jesmo li nasli rastav. */
    if (suma == 0) return 1;

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           uz ogranicenje prvi <= i <= suma:
           - preostala suma je suma - i,
           - sljedeci prvi je barem i + k. */

    for (i = prvi; i <= suma; ++i)
        broj += particije_2(suma - i, k, i + k);

    return broj;
}

    /* Nerekurzivna funkcija za racunanje p_2(n, k).
       Zove rekurzivnu funkciju particije_2,
       s dodatnim argumentom prvi = 1. */

int p_2(int n, int k)
{
        /* Poziv rekurzivne funkcije particije_2, s prvi = 1. */
    return particije_2(n, k, 1);
}

int main(void)
{
    int n, k;

    printf(" Upisi prirodni broj n i cijeli broj k >= 0: ");
    scanf("%d%d", &n, &k);

    broj_poziva = 0u;

    printf("\n\n");
    printf(" Broj particija p_2(%d, %d) = %d\n",
           n, k, p_2(n, k));
    printf(" Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
