#include <stdio.h>

  /* Particije - Varijacija 2:
       Broj rastava zadanog prirodnog broja n u sumu
     nepadajucih (prirodnih) pribrojnika, s tim da je
     razlika susjednih pribrojnika barem k, gdje je
     k >= 0 zadani cijeli broj.
     Dozvoljen je i samo jedan pribrojnik.

     Rekurzivno generira (broji i zbraja) sve particije.
     Osnovni rekurzivni algoritam (poput parts_1.c, par_0.c).
       Varijabla k je globalna (jer se ne mijenja),
     zato da ne mora biti argument rekurzivne funkcije.

     Umjesto citanja brojeva n i k,
     ispisuje broj opisanih particija p_2(n, k),
     za sve brojeve n = 1, ..., 100, uz fiksni k = 3.
     Ispisuje i broj rekurzivnih poziva funkcije.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;

    /* Globalna varijabla k za razliku susjednih pribrojnika. */

int k = 3;


    /* Nadji sve opisane particije broja suma u kojima je
       prvi (sljedeci) pribrojnik barem jednak broju prvi. */
    /* Rekurzivna funkcija koristi globalnu varijablu k. */

int particije_2(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Provjera kraja rekurzije i jesmo li nasli rastav. */
    if (suma == 0) return 1;

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           uz ogranicenje prvi <= i <= suma:
           - preostala suma je suma - i,
           - sljedeci prvi je barem i + k. */

    for (i = prvi; i <= suma; ++i)
        broj += particije_2(suma - i, i + k);

    return broj;
}

    /* Nerekurzivna funkcija za racunanje p_2(n, k).
       Zove rekurzivnu funkciju particije_2,
       s dodatnim argumentom prvi = 1. */

int p_2(int n, int kk)
{
        /* Postavi globalni k (za rekurziju) na zadani kk. */
    k = kk;

        /* Poziv rekurzivne funkcije particije_2, s prvi = 1. */
    return particije_2(n, 1);
}

int main(void)
{
    int n;

        /* Zaglavlje tablice. */
    printf("\n");
    printf("        Broj particija        Broj poziva\n");
    printf(" ------------------------------------------\n");

    for (n = 1; n <= 100; ++n ) {

            /* Inicijalizacija globalnog brojaca poziva. */
        broj_poziva = 0u;

            /* Redak tablice. */
        printf("   p_2(%3d, %d) = %10d    %10u\n",
               n, k, p_2(n, k), broj_poziva);
    }

    return 0;
}
