#include <stdio.h>

  /* Ucitava n i pise broj particija broja n,
     tj. broj rastava broja n u sumu nepadajucih
     prirodnih brojeva.
     Rekurzivno broji i zbraja sve generirane particije.

     Osnovni algoritam - ima puno rekurzivnih poziva
     koji ne generiraju nove particije,
     tj. ima puno vise poziva od broja particija.
     (v. par_0.c).

     Umjesto citanja broja n, ispisuje broj particija
     za sve brojeve n = 1, ..., 100.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;

    /* Nadji sve particije broja suma u kojima je prvi (sljedeci)
       pribrojnik barem jednak prvi. */

int particije(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

    if (suma == 0) return 1;

        /* else */

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           za prvi <= i <= suma. */
    for (i = prvi; i <= suma; ++i)
        broj += particije(suma - i, i);
    return broj;
}

int main(void)
{
    int n;

    for (n = 1; n <= 100; ++n ) {

        broj_poziva = 0u;
        printf("\n Broj particija p(%d) = %d\n",
               n, particije(n, 1) );

        printf(" Broj poziva funkcije = %u\n",
               broj_poziva);
    }

    return 0;
}
