#include <stdio.h>

  /* Ucitava n i pise broj particija broja n,
     tj. broj rastava broja n u sumu nepadajucih
     prirodnih brojeva.
     Rekurzivno broji i zbraja sve generirane particije.

     Prva ideja za efikasniji zavrsetak rekurzije,
     tj. izbjegavanje nepotrebnih poziva.
     Realizacija NE VALJA = daje pogresan broj particija.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;

    /* Nadji sve particije broja suma u kojima je prvi (sljedeci)
       pribrojnik barem jednak prvi. */

int particije(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Ideja za "ubrzanje" pocetnog algoritma iz par_0.c,
           s ciljem smanjenja broja rekurzivnih poziva:

           U petlji po i sigurno ima (bar) jedna particija,
           ona za i = suma (na gornjoj granici petlje).
           Tad je particija gotova (preostala suma je 0). Zato nema
           smisla trositi jos jedan rekurzivni poziv za test da je
           preostala suma = 0 (taj poziv vrati 1), vec odmah povecamo
           broj particija za 1 (bez poziva). */
    ++broj ;
        /* Medjutim, to NE VALJA, jer NE vodi racuna o donjoj
           granici petlje, tj. da mora biti i prvi <= suma. */

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           za prvi <= i < suma (bez i = suma). */
    for (i = prvi; i < suma; ++i)
        broj += particije(suma - i, i);

    return broj;
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

    broj_poziva = 0u;

    printf("\n Broj particija p(%d) = %d\n",
           n, particije(n, 1) );

    printf("\n Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
