#include <stdio.h>

  /* Ucitava n i pise broj particija broja n,
     tj. broj rastava broja n u sumu nepadajucih
     prirodnih brojeva.
     Rekurzivno broji i zbraja sve generirane particije.

     Prva ideja za efikasniji zavrsetak rekurzije,
     tj. izbjegavanje nepotrebnih poziva.
     KOREKTNA realizacija.
     Radi dobro, ali jos uvijek ima nepotrebnih poziva.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;

    /* Nadji sve particije broja suma u kojima je prvi (sljedeci)
       pribrojnik barem jednak prvi. */

int particije(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Popravak ideje za ubrzanje iz par_1bad.c:

           Testiramo je li suma >= prvi. Ako je, onda sigurno
           ima jedna particija - ona za i = suma, pa odmah
           povecamo broj particija za 1 (bez poziva). */

        /* Ako je suma >= prvi, za i = suma, povecaj broj za 1. */
    if (suma >= prvi) ++broj;

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           za prvi <= i < suma (bez i = suma). */
    for (i = prvi; i < suma; ++i)
        broj += particije(suma - i, i);

    return broj;
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

    broj_poziva = 0u;

    printf("\n Broj particija p(%d) = %d\n",
           n, particije(n, 1) );

    printf("\n Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
