#include <stdio.h>

  /* Pokazivaci i const. */

int main(void)
{
        /* Obicno polje, smije se mijenjati. */
    double x[] = {0.1, 0.2, 0.3};

        /* Konstantno polje, ne smije se mijenjati. */
    const double y[] = {0.1, 0.2, 0.3};

        /* Pokazivac na konstantni double. */
    const double *p1;       /* Ptr na konst. double. */

        /* Konstantni pokazivac na double. */
    double * const p2 = x;  /* Konst. ptr na double. */

        /* Konstantni pokazivac na konstantni double. */
    const double * const p3 = y;
                   /* Konst. ptr na konst. double. */

        /* p1 NIJE konstantni pokazivac, tj. smije
           biti na lijevoj strani pridruzivanja.
           Medjutim, *p1 je konstantni double, pa NE smije
           biti na lijevoj strani pridruzivanja. */
    p1 = x;  /* OK, ali x NE mogu mijenjati kroz p1. */
    p1[1] = 4.0;    /* GRESKA. */

        /* p2, p3 su konstantni pokazivaci, tj. NE smiju
           biti na lijevoj strani pridruzivanja. */
    p2 = &x[2];     /* GRESKA. */
    p3 = &y[2];     /* GRESKA. */

        /* *p2 NIJE konstantni double pa smije biti
           biti na lijevoj strani pridruzivanja. */
    *p2 = x[1];     /* OK. */

        /* *p3 je konstantni double, tj. NE smije
           biti na lijevoj strani pridruzivanja. */
    *p3 = 4.0;      /* GRESKA. */

    return 0;
}
