#include <stdio.h>

  /* Razne implementacije funkcije strcat.
     Kao i pravi strcat, funkcija vraca char *
     = pokazivac na "produljeni" prvi string. */

  /* Napomena: ako neku funkciju nazovemo strcat,
     linker javlja gresku (vec postoji u C biblioteci). */


    /* Skracena varijanta s pokazivacima, inkrementira pokazivace u uvjetu
       i interpretira '\0' kao laz. */

char *strcat_1(char *dest, const char *src)
{
    char *p = dest;

    while (*p++);    /* Pomak do IZA '\0' u dest. */
    --p;             /* Natrag na zadnji '\0'. */
    while (*p++ = *src++);    /* Kopiraj src u dest. */

    return dest;
}

    /* Varijanta s indeksima. */

char *strcat_2(char s[], const char t[])
{
    int i = 0, j = 0;

    while(s[i] != '\0') ++i;
    while((s[i++] = t[j++]) != '\0');

    return s;
}

    /* Glavni program - testira sve varijante funkcije. */

int main(void)
{
    char prvi[80] = "Programiranje", drugi[80] =" 2";

    printf(" Pocetni stringovi:\n");
    printf("   prvi = \"%s\"\n", prvi);
    printf("  drugi = \"%s\"\n", drugi);

    printf("\n");

        /* Jednom doda drugi. */
    printf("  strcat_1 = \"%s\"\n", strcat_1(prvi, drugi));
        /* Drugi puta doda drugi. */
    printf("  strcat_2 = \"%s\"\n", strcat_2(prvi, drugi));

    return 0;
}
