#include <stdio.h>

  /* Razne implementacije funkcije strlen.
     Ovdje je vrijednost funkcije tipa int,
     a pravi strlen vraca vrijednost tipa size_t. */

  /* Napomena: ako neku funkciju nazovemo strlen,
     linker javlja gresku (vec postoji u C biblioteci). */


    /* Varijanta s indeksima, uz brojac pomaka do nul-znaka. */

int strlen_1(const char *s)
{
    int n;

    for (n = 0; s[n] != '\0'; ++n);
        /* for je prazan! */

    return n;
}

    /* Varijanta s pokazivacima, uz brojac pomaka do nul-znaka. */

int strlen_2(const char *s)
{
    int n = 0;

    while (*s++ != '\0')    /* (*s++) */
        ++n;

    return n;    /* Na sto pokazuje s na kraju? */
}

    /* Varijanta s pokazivacima, uz razliku pokazivaca. */

int strlen_3(const char *s)
{
    char *p = s;

    while (*p != '\0')    /* (*p) */
        ++p;

    return p - s;
}

    /* Pogresna varijanta s pokazivacima, uz razliku pokazivaca. */

int strlen_4(const char *s)
{
    char *p = s;

    while (*p++ != '\0');    /* (*p++) */

    return p - s;
}

    /* Glavni program - testira sve varijante funkcije. */

int main(void)
{
    char string[80] = "Programiranje 2";

    printf(" Pocetni string:\n");
    printf("  string = \"%s\"\n", string);

    printf("\n");

    printf("  strlen_1 = %d\n", strlen_1(string));
    printf("  strlen_2 = %d\n", strlen_2(string));
    printf("  strlen_3 = %d\n", strlen_3(string));
    printf("  strlen_4 = %d\n", strlen_4(string));

    return 0;
}
