#include <stdio.h>
#include <stdlib.h>

  /* Dinamicka alokacija matrice tipa (m, n).
     Po C90 standardu, broj stupaca mora biti konstanta (zbog tipa).
     Po C99 standardu, broj stupaca moze biti vrijednost varijable. */

int main(void)
{
    int n = 10;    /* Stvarni broj stupaca matrice A. */
    int m;         /* Broj redaka matrice A, nije inicijaliziran. */

        /* Pokazivaci na dinamicki alocirane matrice. */
    double (*p1)[10];    /* Konstantni broj stupaca. */
    double (*p2)[n];     /* Broj stupaca je vrijednost varijable. */

    m = 5;    /* Broj redaka u A. */

        /* Alokacija s fiksnim i varijabilnim brojem stupaca. */
    p1 = (double(*)[10]) malloc(m * 10 * sizeof(double));
    p2 = (double(*)[n])  malloc(m *  n * sizeof(double));

        /* Ispis velicina i adresa. */
    printf(" sizeof(p1)       = %3u,   p1       = %p\n",
           sizeof(p1), p1);
    printf(" sizeof(p1[1])    = %3u,   p1[1]    = %p\n",
           sizeof(p1[1]), p1[1]);
    printf(" sizeof(p1[1][1]) = %3u,  &p1[1][1] = %p\n",
           sizeof(p1[1][1]), &p1[1][1]);
    printf("\n");
    printf(" sizeof(p2)       = %3u,   p2       = %p\n",
           sizeof(p2), p2);
    printf(" sizeof(p2[1])    = %3u,   p2[1]    = %p\n",
           sizeof(p2[1]), p2[1]);
    printf(" sizeof(p2[1][1]) = %3u,  &p2[1][1] = %p\n",
           sizeof(p2[1][1]), &p2[1][1]);

    free(p1);
    free(p2);

    return 0;
}
