#include <stdio.h>
#include <stdlib.h>

    /* Tip za pokazivac na element liste. */

/*  NE SMIJE OVAKO --- tip element jos NIJE definiran:
typedef element* lista;

    To smijemo napisati tek NAKON deklaracije tipa element.
    Zato koristimo struct s pomocnim imenom tipa _element.
*/
typedef struct _element* lista;

    /* Tip za element liste. */

typedef struct _element {
    int broj;            /* Sadrzaj je broj. */
    lista sljed;         /* Pokazivac na sljedeci element u listi. */
} element;

lista ubaci_sprijeda(lista prvi, int broj)
{
    lista pom = NULL;
/*
    if ((pom = (lista) malloc(sizeof(element))) == NULL)
*/
    pom = (lista) malloc(sizeof(element));
    if (pom == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(EXIT_FAILURE);    /* exit(1); */
    }

    pom->broj = broj;
    pom->sljed = prvi;

        /* Ne treba prvi = pom, vec samo ovo: */
    return pom;
}

int broj_elemenata(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed)
        ++brojac;

    return brojac;
}

void ispisi_listu(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed) {
        printf(" Element %2d, broj = %2d\n",
               ++brojac, pom->broj);
    }

    return;
}

int main(void)
{
    lista prvi = NULL;    /* Prazna lista! */
    int broj;

        /* Citanje niza brojeva za listu, do broj = 0.
           To je oznaka kraj niza, ali nije clan niza. */
        /* Poredak brojeva u listi je obratan od redoslijeda
           citanja, jer dodajemo na pocetak liste. */

    printf("Upisite niz cijelih brojeva (0 = kraj).\n");
    do {
        printf("Sljedeci broj:\n");
        scanf("%d", &broj);
        if (broj != 0)
            prvi = ubaci_sprijeda(prvi, broj);
    } while (broj != 0);

    printf("\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata(prvi));

    ispisi_listu(prvi);

    return 0;
}
