/* ======================================================================== */

    /* Rekurzivna funkcija za sortirano spajanje (merge)
       dvije sortirane liste. */

    /* Rekurzivno izbacuje manji prvi element iz pripadne liste,
       stavlja ga kao prvi element u spojenoj listi, a zatim na njega
       spaja listu dobivenu spajanjem dvije preostale liste
       (liste sljedbenika izbacenog elementa i one druge).
       Rekurzija = obrada liste sljedbenika izbacenog elementa.
       Mora paziti na praznu listu (nema prvog) - tada nema rekurzije,
       sto odgovara kraju rekurzije. */

lista merge_rek(lista prvi_1, lista prvi_2)
{
        /* Sortirano spaja dvije liste (merge). */

    lista prvi;

        /* Ako je jedna lista prazna, rezultat je ona druga lista.
           Tada nema rekurzije (= prekid). */
    if (prvi_1 == NULL) return prvi_2;
    if (prvi_2 == NULL) return prvi_1;

        /* U nastavku obrade, obje liste sigurno NISU prazne. */

        /* Nadji manjeg, od prvog iz prve liste i prvog iz druge liste.
           Stavi ga kao pocetak (prvi element) u spojenoj listi.
           Skrati pripadnu listu za prvi element (kao da ga izbacimo
           s pocetka njegove liste), ponovi cijeli posao na listi
           sljedbenika izbacenog elementa i onoj drugoj listi (spoji ih).
           Tako spojenu (kracu) listu stavi kao listu sljedbenika novog
           prvog (= spoji na prvog), sto daje cijelu spojenu listu. */

    if (prvi_1->broj <= prvi_2->broj) {
        prvi = prvi_1;
        prvi->sljed = merge_rek(prvi_1->sljed, prvi_2);
    }
    else {
        prvi = prvi_2;
        prvi->sljed = merge_rek(prvi_1, prvi_2->sljed);
    }

        /* Vrati pocetak spojene sortirane liste. */
    return prvi;
}

/* ======================================================================== */
