#include <stdio.h>
#include <stdlib.h>

  /* Ponasanje funkcija ftell, feof, ferror.
     Pisanje, citanje do kraja, dodavanje na kraj.
     Ovdje NEMA problema pri prijelazu s citanja na pisanje,
     jer je citanje stiglo na kraj datoteke. */

int main(void)
{
    char *f_name = "fpe_ap.dat";
    FILE *fp;
    int c, cret, i;

        /* Otvaramo datoteku za pisanje. */

    if ((fp = fopen(f_name, "w")) == NULL) {
        fprintf(stderr, "Ne mogu pisati u: %s!\n",
                f_name);
        exit(1);
    }

        /* Kreiramo datoteku od 4 znaka: abcd. */

    printf(" Pisanje u datoteku:\n");

    printf("   Pocetak:    ftell = %ld,  feof = %2d,  ferror = %d\n",
           ftell(fp), feof(fp), ferror(fp));

    for (c = 'a'; c <= 'd'; ++c) {
        cret = fputc(c, fp);
        if (cret >= 0)
            printf("   znak = %2c,", cret);  /* Znak. */
        else
            printf("   znak = %2d,", cret);  /* Broj. */

        printf("  ftell = %ld,  feof = %2d,  ferror = %d\n",
               ftell(fp), feof(fp), ferror(fp));

        if (cret == EOF) {
            fprintf(stderr, "Greska u pisanju.\n");
            exit(2);
        }
    }
    fclose(fp);

        /* Otvaramo datoteku za dodavanje i citanje. */

    if ((fp = fopen(f_name, "a+")) == NULL) {
        fprintf(stderr, "Ne mogu citati iz: %s!\n",
                f_name);
        exit(3);
    }

        /* Sekvencijalno citamo tu datoteku. */

    printf(" Citanje iz datoteke:\n");

    printf("   Pocetak:    ftell = %ld,  feof = %2d,  ferror = %d\n",
           ftell(fp), feof(fp), ferror(fp));

    for (i = 0; i < 6; ++i) {
/*
        printf(" znak = %2d\n", fgetc(fp));
*/
        if ((c = fgetc(fp)) >= 0)
            printf("   znak = %2c,", c);  /* Znak. */
        else
            printf("   znak = %2d,", c);  /* Broj. */

        printf("  ftell = %ld,  feof = %2d,  ferror = %d\n",
               ftell(fp), feof(fp), ferror(fp));
    }

        /* Oprez pri prijelazu s citanja na pisanje!
           Ovdje smijemo, jer je citanje stiglo na
           kraj datoteke. */

        /* Sekvencijalno dodajemo u datoteku. */

    printf(" Dodavanje u datoteku:\n");

    printf("   Pocetak:    ftell = %ld,  feof = %2d,  ferror = %d\n",
           ftell(fp), feof(fp), ferror(fp));

    for (c = 'e'; c <= 'f'; ++c) {
        cret = fputc(c, fp);
        if (cret >= 0)
            printf("   znak = %2c,", cret);  /* Znak. */
        else
            printf("   znak = %2d,", cret);  /* Broj. */

        printf("  ftell = %ld,  feof = %2d,  ferror = %d\n",
               ftell(fp), feof(fp), ferror(fp));

        if (cret == EOF) {
            fprintf(stderr, "Greska u pisanju.\n");
            exit(4);
        }
    }
    fclose(fp);

    return 0;
}
