#include <stdio.h>

/****************************************************************************/

  /* Sortiranje QuickSort algoritmom.
     Prvi element x[l] je kljucni element
     i dovodimo ga na pravo mjesto u polju.
     Zamjene u kodu (bez swap). */

    /* Rekurzivna funkcija za quick_sort. */

void quick_sort(int x[], int l, int d)
{
    int i, j, temp;

        /* Test duljine/granica polja i brzi povratak. */
    if (l >= d) return;

    i = l + 1;
    j = d;

        /* Zbog l < d, u prvom prolazu je i <= j.
           Zato koristimo do ... while petlju.
           Prolaz mora i za i == j */
    do {
        while (i <= d && x[i] <= x[l]) ++i;
            /* Za brzinu (Intel C):
               NE koristimo x[l] kao granicnik,
               vec testiramo i indeks j. */
        while (j > l  && x[j] > x[l]) --j;
        if (i < j) {
            temp = x[i];
            x[i] = x[j];
            x[j] = temp;
                /* Pomakni i, j, nakon zamjene. */
            ++i; --j;
        }
    } while (i <= j);

        /* Provjera zamjene za kljucni element. */
    if (l < j) {
            /* Kljucni nije najmanji u polju,
               zamjena x[l] i x[j]. */
        temp = x[l];
        x[l] = x[j];
        x[j] = temp;
            /* Nema provjere duljine/granica za donji dio. */
        quick_sort(x, l, j - 1);
    }
        /* Nema provjere duljine/granica za gornji dio.
           Ovdje koristimo da je i = j + 1. */
    quick_sort(x, i, d);

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    quick_sort(x, 0, n - 1);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
